<?php

class CMenuEvents {

	private $env;

	public function __construct(&$env) {
		$this->env = &$env;
	}

	public function windowRefresh() {
		$this->toolBarReload();
	}

	public function menuFileEnd() {
		Gtk::main_quit();
	}

public function menuCommandsPrintDir() {
		
			if ($this->env['modules']['moduleViewLeft']->isActive()) {
			$module = $this->env['modules']['moduleViewLeft'];
			$module_dst = $this->env['modules']['moduleViewRight'];
		} else if ($this->env['modules']['moduleViewRight']->isActive()) {
			$module = $this->env['modules']['moduleViewRight'];
			$module_dst = $this->env['modules']['moduleViewLeft'];
		}

		if (!isset($module))
			return;

		$dialog = new GtkMessageDialog(
			$this->env['gui']['window'],
			0,
			Gtk::MESSAGE_QUESTION,
			Gtk::BUTTONS_OK_CANCEL,
			$this->env['modules']['translationModule']->translate('printdir_dialog')
		);
		$dialog->get_child()->pack_end(new GtkEntry($this->env['modules']['translationModule']->translate('printdir_file')));
		$dialog->show_all();
		$result = $dialog->run();
		$children = $dialog->get_child()->get_children();
		$myEntry = array_pop($children);
		$myEntry = array_pop($children);

		$file = $myEntry->get_text();
		$dialog->destroy();

		if ($result == Gtk::RESPONSE_OK) {
			$this->env['modules']['write']->writeDir($module->getDirPath(),$module_dst->getDirPath().$file.'.txt',FALSE,$module->getActualFSModule(),$module_dst->getActualFSModule());
		}

	}

	public function menuAboutHelp() {
		$aboutWnd = new GtkAboutDialog();

		$aboutWnd->set_name('MMFM');
		$aboutWnd->set_version('0.0.1');
		$aboutWnd->set_logo(GdkPixbuf::new_from_file('./imgs/logo.png'));
		$aboutWnd->set_comments('Multiplatform Modular File Manager');
		$aboutWnd->set_copyright('Copyright (c) 2007');
		$aboutWnd->set_website('http://sourceforge.net/projects/mmfm');

		$artists = Array('Pospisil Jan'); // grafika
		$authors = Array('Navratil Tomas','Pospisil Jan','Vrbicky Jiri');
		$documenters = Array('noenes yet');
		$aboutWnd->set_authors($authors);
		$aboutWnd->set_artists($artists);
		$aboutWnd->set_documenters($documenters);
		$aboutWnd->set_translator_credits('noenes yet');
		$aboutWnd->set_license('GNU Licence');

//		$aboutWnd->set_email_hook();
//      Sets a global callback to be called when a user activates an email link in the dialog. 
//		$aboutWnd->set_logo_icon_name(<spec jmeno z databaze>);
//		$aboutWnd->set_url_hook();
//      Sets a global callback for all URL links in the dialog. 
// ?		$aboutWnd->set_website_label('Adresa bude....');

		$aboutWnd->run();
	}
	
	public function menuModulesLang() {
		
		$this->refreshLanguage();
		
		$wnd = new GtkWindow();
		$wnd->set_title($this->env['modules']['translationModule']->translate('langView_winTitle'));
		$wnd->set_default_size(400, 300);
		
		$vBox = new GtkVBox(false, 1);
		$wnd->add($vBox);
		
		$model = new GtkListStore(Gtk::TYPE_STRING, Gtk::TYPE_STRING);
		$files = array();
		$files = $this->env['modules']['translationModule']->getLanguages();
		
		//nacteni jazyku
		$currentLanguage = $this->env['modules']['translationModule']->getLanguage();
		for($i=0; $i<count($files); $i++){
			if($currentLanguage == $files[$i]){
				$model->insert($i, array($files[$i],
					       $this->env['modules']['translationModule']->translate('lang_set')));
			} else {
				$model->insert($i, array($files[$i], 'ok'));
			}
		}
		
		$langTreeView = new GtkTreeView($model);
		$langTreeView->set_search_column(0);
		
		$crLang = new GtkCellRendererText();
		$crSet = new GtkCellRendererText();
		
		$crLang->set_property('width', 100);
		$crSet->set_property('width', 100);
		
		$clmnLang = new GtkTreeViewColumn($this->env['modules']['translationModule']->translate('langView_name'));
		$clmnSet = new GtkTreeViewColumn($this->env['modules']['translationModule']->translate('langView_state'));
	
		$clmnLang->pack_start($crLang, true);
		$clmnSet->pack_start($crSet, true);
		
		$clmnLang->set_attributes($crLang, 'text', 0);
		$clmnSet->set_attributes($crSet, 'text', 1);

		$langTreeView->append_column($clmnLang);
		$langTreeView->append_column($clmnSet);
		
		$vBox->pack_start($langTreeView, true, true, 1);
		$langTreeView->show();
		
		$hBox = new GtkHBox(false, 1);
		$vBox->pack_start($hBox, false, false, 1);
		
		$buttonOk = new GtkButton($this->env['modules']['translationModule']->translate('langButton_ok'));
		$buttonApply = new GtkButton($this->env['modules']['translationModule']->translate('langButton_apply'));
		
		$buttonApply->connect_simple('clicked', array('CMenuEvents', 'applyLang'), $langTreeView, $wnd, $this);
		$buttonOk->connect_simple('clicked', array('CMenuEvents', 'buttonOk'), $wnd);
		
		$hBox->pack_start($buttonApply, false, true, 1);
		$buttonApply->show();
		$hBox->pack_start($buttonOk, false,true, 1);
		$buttonOk->show();
		
		$wnd->show_all();
	}
	
	function applyLang(&$langTreeView, &$wnd, $events){
		//najit oznaceny jazyk;
		$selection = $langTreeView->get_selection();
		list($model, $iter) = $selection->get_selected();
		$selectedLang = $model->get_value($iter, 0);
		
		//nastavit jazyk:( ;
		$events->changeLanguage($selectedLang);
		
		//zavrit okno;
		$wnd->destroy();
	}
	
	function buttonOk(&$wnd){
		$wnd->destroy();
	}
	
	public function changeLanguage($selectedLang){
		
		//array of attribites in language file;
		$menuAttributes = array('mnu_file', 'smnu_fileEnd', 'mnu_folder', 'mnu_commands', 'smnu_commandsPack',
					'smnu_commandsUnPack', 'smnu_commandsSearch', 'smnu_commandsPrintDir',
					'mnu_modules', 'smnu_modulesLang', 'mnu_about', 'smnu_aboutHelp',
					'tlbr_reload', 'tlbr_view', 'tlbr_edit','tlbr_copy', 'tlbr_move','tlbr_mkdir', 'tlbr_delete');
		
		
		//set language, all words to array;
		$this->env['modules']['translationModule']->setLanguage($selectedLang);
		
		//get text from labels;
		//menu;
		$labels['mnu_file'] = $this->env['glade']->get_widget('menuFile')->get_child();
		$labels['smnu_fileEnd'] = $this->env['glade']->get_widget('menuFileEnd')->get_child();
		$labels['mnu_folder'] = $this->env['glade']->get_widget('menuFolder')->get_child();
		$labels['mnu_commands'] = $this->env['glade']->get_widget('menuCommands')->get_child();
		$labels['smnu_commandsPack'] = $this->env['glade']->get_widget('menuCommandsPack')->get_child();
		$labels['smnu_commandsUnPack'] = $this->env['glade']->get_widget('menuCommandsUnPack')->get_child();
		$labels['smnu_commandsSearch'] = $this->env['glade']->get_widget('menuCommandsSearch')->get_child();
		$labels['smnu_commandsPrintDir'] = $this->env['glade']->get_widget('menuCommandsPrintDir')->get_child();
		$labels['mnu_modules'] = $this->env['glade']->get_widget('menuModules')->get_child();
		$labels['smnu_modulesLang'] = $this->env['glade']->get_widget('menuModulesLang')->get_child();
		$labels['mnu_about'] = $this->env['glade']->get_widget('menuAbout')->get_child();
		$labels['smnu_aboutHelp'] = $this->env['glade']->get_widget('menuAboutHelp')->get_child();
		//function panel;
		$labels['tlbr_reload'] = $this->env['glade']->get_widget('toolBarReload')->get_child()->get_child();
		$labels['tlbr_view'] = $this->env['glade']->get_widget('toolBarView')->get_child()->get_child();
		$labels['tlbr_edit'] = $this->env['glade']->get_widget('toolBarEdit')->get_child()->get_child();
		$labels['tlbr_copy'] = $this->env['glade']->get_widget('toolBarCopy')->get_child()->get_child();
		$labels['tlbr_move'] = $this->env['glade']->get_widget('toolBarMove')->get_child()->get_child();
		$labels['tlbr_mkdir'] = $this->env['glade']->get_widget('toolBarMkdir')->get_child()->get_child();
		$labels['tlbr_delete'] = $this->env['glade']->get_widget('toolBarDelete')->get_child()->get_child();
		
		//set labels;
		foreach($menuAttributes as $attribute){
			$labels[$attribute]->set_text($this->env['modules']['translationModule']->translate($attribute));
		}
		$this->env['modules']['moduleViewLeft']->refresh();
		$this->env['modules']['moduleViewRight']->refresh();
		

	}

	public function toolBarReload() {
		$this->env['modules']['moduleViewLeft']->refresh();
		$this->env['modules']['moduleViewRight']->refresh();
	}

	public function toolBarView() {
		$path = '';

		if ($this->env['modules']['moduleViewLeft']->isActive())
			$module = $this->env['modules']['moduleViewLeft']; 
		else if ($this->env['modules']['moduleViewRight']->isActive())
			$module = $this->env['modules']['moduleViewRight'];
			
		if (!isset($module))
			return;

		$path = $module->getWorkingFileSelected();
		$filename = $module->getFileSelected();

		$vWnd = new GtkWindow();
		$vWnd->set_title($this->env['modules']['translationModule']->translate('CMenuEvents_file_viewer').'('.$filename.')');
		$vWnd->set_default_size(400, 400);
		$vWnd->set_position(GTK::WIN_POS_CENTER);

		$textBuffer = new GtkTextBuffer();
		$textView = new GtkTextView();
		$textView->set_buffer($textBuffer);
		$textView->set_editable(false);
		
		$btn_ascii = new GtkButton($this->env['modules']['translationModule']->translate('CMenuEvents_btn_ascii'));
		$btn_hex = new GtkButton($this->env['modules']['translationModule']->translate('CMenuEvents_btn_hex'));

		$boxh = new GtkHBox();
		$boxv = new GtkVBox();

		$scrl = new GtkScrolledWindow();
		$scrl->set_property('hscrollbar-policy',Gtk::POLICY_AUTOMATIC);
		$scrl->set_property('vscrollbar-policy',Gtk::POLICY_AUTOMATIC);
		$scrl->add_with_viewport($textView);

		$boxh->pack_start($btn_ascii, false, true);
		$boxh->pack_start($btn_hex, false, true);

		$boxv->pack_start($boxh, false);
		$boxv->pack_start($scrl, true, true);
		
		$vWnd->add($boxv);
		$vWnd->show_all();

		self::toolBarView_switch($path, $textBuffer, $scrl, 1);

		$btn_ascii->connect_simple('clicked', Array('CMenuEvents','toolBarView_switch'), $path, $textBuffer, $scrl, 1);
		$btn_hex->connect_simple('clicked', Array('CMenuEvents','toolBarView_switch'), $path, $textBuffer, $scrl, 2);
	}

	static public function toolBarView_switch($path, $textBuffer, $scrl, $id) {
		if (($id != 1) && ($id != 2))
			throw new Exception($this->env['modules']['translationModule']->translate('exception_illegal_func'));
		if ($id == 1) {
			$scrl->set_property('hscrollbar-policy',Gtk::POLICY_AUTOMATIC);
			$text = implode('',file($path));
			$len = strlen($text);
			for ($i = 0; $i < $len; $i++) {
				$ascii = ord(substr($text, $i, 1));
				if (($ascii < 32) && ($ascii != 10) && ($ascii != 13) && ($ascii != 9))
					break;
			}
			if ($i < $len)
				$id = 2;
			else
				$textBuffer->set_text($text);
		}
		if ($id == 2) {
			$scrl->set_property('hscrollbar-policy',Gtk::POLICY_NEVER);
			$text = implode('',file($path));
			$data = '';
			$maxaddr = log(strlen($text), 16);
			for ($x = 0; $x < strlen($text); $x++) {
				if ($x%16 == 0) {
					$data .= CMenuEvents::dechex_padding($x, $maxaddr).' | ';
					$tx = '';
				}
				
				$ch = substr($text,$x,1);
				$data .= CMenuEvents::dechex_padding(ord($ch),2).' ';
				if ((ord($ch) < 32) || (ord($ch) > 127))
					$tx .= '.';
				else
					$tx .= $ch;

				if (($x+1)%16 == 0) {
					$data .= " | $tx";
					$data .= "\n";
				}
			}
			$textBuffer->set_text($data);
		}
	}

	public function toolBarEdit() {
		$path = '';

		if ($this->env['modules']['moduleViewLeft']->isActive())
			$path = $this->env['modules']['moduleViewLeft']->getWorkingFileSelected();
		else if ($this->env['modules']['moduleViewRight']->isActive())
			$path = $this->env['modules']['moduleViewRight']->getWorkingFileSelected();

		if ($path == '')
			return;

		if($env['os'] == 'unix')
			exec('run-mailcap "'.str_replace(array('\\','$','"'), array('\\\\','\$','\"'), $path).'" &');
		else
			exec('"'.$path.'"');
	}

	public function toolBarCopy() {
		$this->cpy_mov('copy');
	}

	public function toolBarMove() {
		$this->cpy_mov('move');
	}

	public function toolBarMkdir() {
		
		if ($this->env['modules']['moduleViewLeft']->isActive()) {
			$module = $this->env['modules']['moduleViewLeft'];
		} else if ($this->env['modules']['moduleViewRight']->isActive()) {
			$module = $this->env['modules']['moduleViewRight'];
		}

		if (!isset($module))
			return;

		$dialog = new GtkMessageDialog(
			$this->env['gui']['window'],
			0,
			Gtk::MESSAGE_QUESTION,
			Gtk::BUTTONS_OK_CANCEL,
			$this->env['modules']['translationModule']->translate('funct_mkdir')
		);
		$dialog->get_child()->pack_end(new GtkEntry($this->env['modules']['translationModule']->translate('funct_newDir')));
		$dialog->show_all();
		
		$done = false;
		while (!$done) {
			$result = $dialog->run();

			$children = $dialog->get_child()->get_children();
			$myEntry = array_pop($children);
			$myEntry = array_pop($children);

			$newDir = $myEntry->get_text();

			$path = $module->getDirPath();
			$path .= $module->getActualFSModule()->getSeparator();
			$path .= $newDir;

			if ($result == Gtk::RESPONSE_OK) {
				try {
					$module->getActualFSModule()-> makeDir($path);
					$done = true;
				} catch (Exception $e) {
					$dialog2 = new GtkMessageDialog(
						$this->env['gui']['window'],
						0,
						Gtk::MESSAGE_WARNING,
						Gtk::BUTTONS_OK,
						$e->getMessage()
					);
					$dialog2->run();
					$dialog2->destroy();
				}
				$module->refresh();
			} else
				$done = true;
		}

		$dialog->destroy();
	}

	public function toolBarDelete() {
		
		if ($this->env['modules']['moduleViewLeft']->isActive()) {
			$module = $this->env['modules']['moduleViewLeft'];
		} else if ($this->env['modules']['moduleViewRight']->isActive()) {
			$module = $this->env['modules']['moduleViewRight'];
		}

		if (!isset($module))
			return;

		$path = $module->getDirPath();
		$path .= $module->getActualFSModule()->getSeparator();
		$items = $module->getFileSelection();

		$dialog = new GtkMessageDialog(
			$this->env['gui']['window'],
			0,
			Gtk::MESSAGE_QUESTION,
			Gtk::BUTTONS_YES_NO,
			$this->env['modules']['translationModule']->translate('funct_deleteFrom') . "\n".
			$path."\n".
			$this->env['modules']['translationModule']->translate('funct_deleteFile') . "\n".
			substr(implode(', ',$items), 0, 50)."\n".
			"?"
		);
		$result = $dialog->run();
		$dialog->destroy();

		if ($result == Gtk::RESPONSE_YES) {
			foreach ($items as $item) {
				$module->getActualFSModule()->del($path.$item);
				$module->refresh();
			}
		}

	}

	public static function driverButtonClicked($module, $path) {
		$module->setDirPath($path);
	}

	private function cpy_mov($action) {
		
		if (($action != 'copy') && ($action != 'move'))
			return;

		if ($this->env['modules']['moduleViewLeft']->isActive()) {
			$module_src = $this->env['modules']['moduleViewLeft'];
			$module_dst = $this->env['modules']['moduleViewRight'];
		} else if ($this->env['modules']['moduleViewRight']->isActive()) {
			$module_src = $this->env['modules']['moduleViewRight'];
			$module_dst = $this->env['modules']['moduleViewLeft'];
		}

		if (!isset($module_src) || !isset($module_dst))
			return;


		$src_working_files = $module_src->getWorkingFileSelection();
		$src_files = $module_src->getFileSelection();
		$dst_path = $module_dst->getDirPath();
		$dst_path .= $module_dst->getActualFSModule()->getSeparator();

		$action_msg = ($action == 'copy')?$this->env['modules']['translationModule']->translate('funct_copy'):$this->env['modules']['translationModule']->translate('funct_move');

		$dialog = new GtkMessageDialog(
			$this->env['gui']['window'],
			0,
			Gtk::MESSAGE_QUESTION,
			Gtk::BUTTONS_YES_NO,
			$action_msg." " . $this->env['modules']['translationModule']->translate('funct_cpymovFile') . "\n".
			substr(implode(', ',$src_files), 0, 50)."\n".
					$this->env['modules']['translationModule']->translate('funct_cpymovTo') . "\n".
			$dst_path."\n".
			"?"
		);
		$result = $dialog->run();
		$dialog->destroy();

		if ($result == Gtk::RESPONSE_YES) {
			if ($action == 'copy')
				foreach($src_working_files as $key => $src) {
					$module_dst->getActualFSModule()->cpy($dst_path.$src_files[$key], $src);
					while (Gtk::events_pending()) Gtk::main_iteration();
					$module_src->refresh();
					$module_dst->refresh();
				}
			else
				foreach($src_working_files as $key => $src) {
					$module_dst->getActualFSModule()->move($dst_path.$src_files[$key], $src);
					while (Gtk::events_pending()) Gtk::main_iteration();
					$module_src->refresh();
					$module_dst->refresh();
				}
		}


	}
	
	private function refreshLanguage(){
		
		$this->langDialogWords['langView_name'] = $this->env['modules']['translationModule']->translate('langView_name');
		$this->langDialogWords['langView_state'] = $this->env['modules']['translationModule']->translate('langView_state');
		$this->langDialogWords['langButton_ok'] = $this->env['modules']['translationModule']->translate('langButton_ok');
		$this->langDialogWords['langButton_apply'] = $this->env['modules']['translationModule']->translate('langButton_apply');
		$this->langDialogWords['lang_set'] = $this->env['modules']['translationModule']->translate('lang_set');
		$this->langDialogWords['langView_winTitle'] = $this->env['modules']['translationModule']->translate('langView_winTitle');
	
	}
	
	public function menuCommandsPack(){
		
		if ($this->env['modules']['moduleViewLeft']->isActive()) {
			$module_src = $this->env['modules']['moduleViewLeft'];
			$module_dst = $this->env['modules']['moduleViewRight'];
		} else if ($this->env['modules']['moduleViewRight']->isActive()) {
			$module_src = $this->env['modules']['moduleViewRight'];
			$module_dst = $this->env['modules']['moduleViewLeft'];
		}

		if (!isset($module_src) || !isset($module_dst))
			return;

		$src_files = $module_src->getFileSelection();
		$src_path = $module_src->getDirPath();
		$dst_path = $module_dst->getDirPath();
		//$this->env['modules']['translationModule']->translate('langView_name')
		$dialog = new GtkMessageDialog(
				$this->env['gui']['window'],
				0,
				Gtk::MESSAGE_QUESTION,
				Gtk::BUTTONS_YES_NO,
				$this->env['modules']['translationModule']->translate('pack_files') . "\n".
				substr(implode(', ',$src_files), 0, 50)."\n".
				$this->env['modules']['translationModule']->translate('pack_filesToDir') . "\n".
				$dst_path . "\n" );
		
		$dialog->get_child()->pack_end(new GtkEntry($this->env['modules']['translationModule']->translate('pack_newArchive')));
		$dialog->show_all();
		
		$result = $dialog->run();

		$children = $dialog->get_child()->get_children();
		$myEntry = array_pop($children);
		$myEntry = array_pop($children);

		$newArchiveName = $myEntry->get_text(); //jmeno arhivu;
		
		if ($result == Gtk::RESPONSE_YES){
			
			$archivePath = $dst_path . $newArchiveName;
			$this->env['modules']['zip']->zipFiles($src_path, $src_files, $archivePath);
			
			$dialog->destroy();
		} else {
			$dialog->destroy();
		}
	}
	
	public function menuCommandsUnPack(){
		
		if ($this->env['modules']['moduleViewLeft']->isActive()) {
			$module_src = $this->env['modules']['moduleViewLeft'];
			$module_dst = $this->env['modules']['moduleViewRight'];
		} else if ($this->env['modules']['moduleViewRight']->isActive()) {
			$module_src = $this->env['modules']['moduleViewRight'];
			$module_dst = $this->env['modules']['moduleViewLeft'];
		}

		if (!isset($module_src) || !isset($module_dst))
			return;

		$src_files = $module_src->getFileSelection();
		$src_path = $module_src->getDirPath();
		
		$dst_path = $module_dst->getDirPath();
		
		$dialog = new GtkMessageDialog(
				$this->env['gui']['window'],
				0,
				Gtk::MESSAGE_QUESTION,
				Gtk::BUTTONS_YES_NO,
				$this->env['modules']['translationModule']->translate('unpack_files') . "\n".
				substr(implode(', ',$src_files), 0, 50)."\n".
				$this->env['modules']['translationModule']->translate('pack_filesToDir') . "\n".
				$dst_path . "\n" );
		
		$dialog->show_all();
		
		$result = $dialog->run();
		
		if ($result == Gtk::RESPONSE_YES){
			foreach($src_files as $file){
				$zipFile = $src_path . $file;
				$this->env['modules']['zip']->unZipFiles($zipFile, $dst_path);
			}
			$dialog->destroy();
		} else {
			$dialog->destroy();
		}
	}

	public function menuCommandsSearch() {
		if ($this->env['modules']['moduleViewLeft']->isActive()) {
			$module = $this->env['modules']['moduleViewLeft'];
		} else if ($this->env['modules']['moduleViewRight']->isActive()) {
			$module = $this->env['modules']['moduleViewRight'];
		}

		if (!isset($module))
			return;

		$find = new $this->env['classes']['find'](
			$this->env['gui']['window'],
			$module->getActualFSModule(),
			$module->getDirPath(),
			'',
			$this->env['modules']['translationModule']
		);
		$this->env['gui']['window']->connect_simple('destroy', 'object_callback', $find, 'destroy');
		$find->show();
	}

	static public function dechex_padding($dec, $len) {
		$hex = dechex($dec);
		for($i = 1; $i < $len; $i++) {
			if($dec < pow(16, $i))
				$hex = '0'.$hex;
		}
		return $hex;
		//return strtoupper($hex);
	}

}

?>
